*===============================================================================
$ontext
FILENAME:        scaling.gms
DATE:            30 Nov. 2001

PURPOSE:         File contains the scaling to be used for determining the region
                 shading color, the point size, and the link width.

DETAILS:         -steps:         number of different color shadings.
                 -steps_s:       number of different point sizes.
                 -steps_w:       number of different link widths.

                 -scaling:       table of different color shadings. The shading
                                 value 'size' is between 0-255, with 255 being
                                 no color and 0 being full shading.

                 -scaling_s:     table of different point sizes. The sizes are
                                 1-48.

                 -scaling_w:     table of different link widths. The widths are
                                 1-7.

USER CUSOTMIZATION:
                 If different shadings, sizes and widths are desired, the user
                 simply updates the scaling tables as desired.

$offtext
*===============================================================================


* Set color scaling for regional shading (255=no color, 0=saturated)
Set   steps /0*5/;
Table scaling(steps,*)
      lo         up      size
0   -0.001       0.2     255
1    0.2         0.4     225
2    0.4         0.6     175
3    0.6         0.8     150
4    0.8         0.999   125
5    0.999       1.0     100
;

* Set point size for point scaling  (1-48 up smalels to largest point size)
Set   steps_s /0*5/;
Table scaling_s(steps_s,*)
      lo         up      size
0   -0.001       0.2       5
1    0.2         0.4       8
2    0.4         0.6      12
3    0.6         0.8      15
4    0.8         0.999    20
5    0.999       1.0      25
;

* Set link width for link scaling (1-7up smallest to largest width)
Set   steps_w /0*5/;
Table scaling_w(steps_w,*)
     lo          up      size
0  -0.001        0.2       1
1   0.2          0.4       1
2   0.4          0.6       2
3   0.6          0.8       2
4   0.8          0.999     3
5   0.999        1.0       3
;