*===============================================================================
$ontext

FILENAME:      get_color.gms
DATE:          17 January, 2002
PURPOSE:       Computes the color intensity
INPUT PARAMETERS:
               obj_num   -       numerical value of object
               col       -       base color of shade of object interior

CALLED BY:  $batinclude get_color   obj_num   col   scaleopt
                                      %1      %2      %3  

$offtext
*===============================================================================

$set obj_num     %1
$set col         %2
$set scaleopt    %3

if (%scaleopt%,
   intensity$(maxval=minval) = 1;
   intensity$(maxval>minval) = ( abs(%obj_num%) - minval) / (maxval-minval);
else
   intensity$(maxval=minval) = 1;
   intensity$(maxval>minval) = abs(%obj_num%) / maxval;
);


display intensity;

loop(steps$(scaling(steps,'lo') < intensity and intensity <= scaling(steps,'up')),

  icolor =  65536*(rgbscale("%col%",'r')*scaling(steps,'size')+(1-rgbscale("%col%",'r'))*255)
          +   256*(rgbscale("%col%",'g')*scaling(steps,'size')+(1-rgbscale("%col%",'g'))*255)
          +     1*(rgbscale("%col%",'b')*scaling(steps,'size')+(1-rgbscale("%col%",'b'))*255)
);