*===============================================================================
$ontext
FILENAME:        initialize.gms
DATE:            21 February, 2002

PURPOSE:         Initialization routine for all GAMSmap routines. This routine
                 must be run with the save option (s=0, or other name) in
                 order to use the other routines. The other mapping routines
                 must be run using the restart feature (this will usually be r=0).

USER OPTIONS:    none
$offtext
*===============================================================================

* ---- echo load macro
$setglobal load  "%gams.scrdir%load.scr"
$setglobal tload "%gams.scrdir%tload.scr"
$escape =
$ONECHO > "%load%"
$if a == a * Load %=1 %=2 from %=3
$offlisting
%=1 %=2 /
$call gmsunzip -p TMPGMSMAPDB %=3.txt > "%gams.scrdir%%=3.scr"
$include "%gams.scrdir%%=3.scr"
/;
$onlisting
$OFFECHO  ---- end load script

$ONECHO > "%tload%"
$if a == a * TLoad %=1 %=2 from %=3
$offlisting
Table %=1 
%=2
$call gmsunzip -p TMPGMSMAPDB %=3.txt > "%gams.scrdir%%=3.scr"
$include "%gams.scrdir%%=3.scr"
;
$onlisting
$OFFECHO  ---- end tload script
$escape %

* Define the universe
Alias(uni,*)

$batinclude "%load%" set plants            name_pl
$batinclude "%load%" set plantsname        plants_n
$batinclude "%load%" set states            states
$batinclude "%load%" set statesname(*)     states_n
$batinclude "%load%" set world             world_cntry
$batinclude "%load%" set worldname(*)      world_n
$batinclude "%load%" set uscapsname(*)     uscaps_n
$batinclude "%load%" set worldcapsname(*)  worldcaps_n
$batinclude "%load%" set color             color

Set ca(*) Canada states /
          AB, BC, MB, NB, NF, NT, NS, ON, PE, PQ, SK, YT
/
    rgbc / r, g, b /
;

Set uscaps(*)
    worldcaps(*);
uscaps(states) = yes;
worldcaps(world) = yes;

$ondelim
$batinclude "%tload%" plantscoord(uni,*)      "pltcode,x,y"   coord_pl
$batinclude "%tload%" statescoord(states,*)   "state,x,y"     s_coord
$batinclude "%tload%" worldcoord(world,*)     "world,x,y"     coord_w
$batinclude "%tload%" uscapscoord(*,*)        "states,x,y"    coord_uscaps
$batinclude "%tload%" worldcapscoord(*,*)     "world,x,y"     coord_worldcaps
$batinclude "%tload%" rgb(color,rgbc)         "color,r,g,b"   rgbc
$offdelim

Parameter irgb(color);
irgb(color) = 65536*rgb(color,'r') + 256*rgb(color,'g') + rgb(color,'b');


* Status.log file parameters
scalar    has_errors / 0 /
file      flog       / status.log /

* Link, point and region attributes
Parameter num_ident /0/
          shading(*) / solid 2, fade 50, lightfade 49, none 1/
          num_pt_type(*) /size 1, color 2/
          pt_color(*), pt_size(*)
          link_color(*,*), link_width(*,*);
scalar icolor, isize, iwidth
       intensity
       max_p /-INF/, max_n/ INF/,
       min_p / INF/, min_n/-INF/,
       maxval, minval;

* Shading rgb scale
Table rgbscale(*,*)
         r    g    b
red      0    1    1
blue     1    1    0
green    1    0    1
yellow   0    0    1
magenta  0    1    0
cyan     1    0    0
;

Set   steps /0*5/;
Table scaling(steps,*)
      lo         up      size
0   -0.001       0.2     235
1    0.2         0.4     210
2    0.4         0.6     151
3    0.6         0.8     100
4    0.8         0.999    52
5    0.999       1.0       0
;

* Set point size for point scaling  (1-48 up smalels to largest point size)
Set   steps_s /0*5/;
Table scaling_s(steps_s,*)
      lo         up      size
0   -0.001       0.2       2
1    0.2         0.4       5
2    0.4         0.6       7
3    0.6         0.8       9
4    0.8         0.999    11
5    0.999       1.0      13
;

* Set link width for link scaling (1-7 up smallest to largest width)
Set   steps_w /0*5/;
Table scaling_w(steps_w,*)
     lo          up      size
0  -0.001        0.2       2
1   0.2          0.4       3
2   0.4          0.6       4
3   0.6          0.8       5
4   0.8          0.999     7
5   0.999        1.0       7
;

$escape =
$onecho > "%gams.scrdir%fheader.scr"
$set fname       %=1
$set link        %=2

* Define .MIF and .MID filenames
file fmif /%=fname%=.mif/;
file fmid /%=fname%=.mid/;

put fmif
      'Version 300'
    / 'Charset "WindowsLatin1"'
    / 'Delimiter ","'
    / 'Index 1'
    / 'CoordSys Earth Projection 1, 0';

* Write out .mif header for link map
if(%=link%=,
 if(num_ident,
      put / 'Columns 3'
      / '  Orig       Char(20)'
      / '  Dest       Char(20)'
      / '  Value      Char(20)';
  else
      put / 'Columns 2'
      / '  Orig       Char(20)'
      / '  Dest       Char(20)';
  );
* Write out .mif header for point or region map
else
  if(num_ident,
      put / 'Columns 3'
      / '  ID       Char(20)'
      / '  Name     Char(20)'
      / '  Value    Char(20)';
  else
      put / 'Columns 2'
      / '  ID       Char(20)'
      / '  Name     Char(20)';
  );
);

put / 'Data';


put fmid ''; // deletes fmid

fmif.ap = 1;
fmid.ap = 1;
$offecho 
$escape =

